package fun;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.mockito.Mockito.when;

import org.apache.log4j.Logger;
import org.junit.jupiter.api.Test;
import org.mockito.MockedConstruction;
import org.mockito.MockedStatic;
import org.mockito.Mockito;

class UtilityTest {

    @Test
    void testGetSumMockStatic() throws Exception {
        try (MockedStatic<LoggerBean> mockedStaticLoggerBean = Mockito.mockStatic(LoggerBean.class)) {

            LoggerBean mockedLoggerBean = Mockito.mock(LoggerBean.class);
            mockedStaticLoggerBean.when(LoggerBean::getLoggerBean).thenReturn(mockedLoggerBean);

            when(mockedLoggerBean.getLogger(getClass())).thenReturn(Logger.getLogger(getClass()));

            assertEquals(4, Utility.getSum(2, 2));
        }
    }

    @Test
    void testGetSumMockConstructor() throws Exception {
        try (MockedConstruction<LoggerBean> mocked = Mockito.mockConstruction(LoggerBean.class, (mock, context) -> {

            MockedStatic<LoggerBean> mockedStaticLoggerBean = Mockito.mockStatic(LoggerBean.class);
            mockedStaticLoggerBean.when(() -> LoggerBean.getLoggerBean()).thenReturn(mock);

            when(mock.getLogger(getClass())).thenReturn(Logger.getLogger(getClass()));
        })) {

            assertEquals(4, Utility.getSum(2, 2));
        }
    }

}
